#ifndef DIYA_SHELL_H
#define DIYA_SHELL_H
#include <stdint.h>
#include "base.h"

#define DIYA_TYPE_SHELL (diya_shell_get_type())
G_DECLARE_DERIVABLE_TYPE(DiyaShell, diya_shell, DIYA, SHELL, DiyaObject)

#define DIYA_TYPE_WAYLAND (diya_wayland_get_type ())
G_DECLARE_FINAL_TYPE (DiyaWayland, diya_wayland, DIYA, WAYLAND, DiyaShellObject)

struct wl_registry;

typedef void (*wl_protocol_manager_register_t)(struct wl_registry*, uint32_t,DiyaShell*);

struct _DiyaShellClass
{
    DiyaObjectClass parent_class;
    wl_protocol_manager_register_t foreign_register;
    wl_protocol_manager_register_t virtual_keyboard_register;
};

void diya_shell_wayland_init(DiyaShell *shell);
DiyaWayland * diya_shell_get_wayland(DiyaShell* shell);


#endif